/*
 * -----------------------------------------------------------
 *   Copyright (c) Youssef Hmamouche - All Rights Reserved.
 *
 *    This software is subject to the General Public License.
 * -----------------------------------------------------------
 */

/**
 * This file contains all the functions used to display the very first blue splash 
 * screen.
 */

#include "acknowledge.h"
#include "dbg.h"
#include "lkcp.h"

extern int lkcp_mode;

#ifdef DEBUG
extern FILE* f;
#endif

void draw_acknowledge(WINDOW* acknowledge){
        int row=0,col=0;
	LOG_CALL(0);
        (void) box(acknowledge, ACS_VLINE, ACS_HLINE);
        (void) wbkgd(acknowledge, COLOR_PAIR(7));
        (void) getmaxyx(acknowledge, row, col);
        (void) wmove(acknowledge, (row/3)-2 ,(col/3));
        (void) wattron(acknowledge, A_BOLD);
        (void) wprintw(acknowledge, "Live Kernel Configuration Panel %s", LKCP_VERSION);
        (void) wattroff(acknowledge, A_BOLD);
        (void) wmove(acknowledge, (row/3)+3, 1);
        (void) wprintw(acknowledge, "Press ");
        (void) wattron(acknowledge, A_BOLD);
        (void) wprintw(acknowledge, "<Escape> ");
        (void) wattroff(acknowledge, A_BOLD);
        (void) wprintw(acknowledge, "to exit this screen. Then press the corresponding ");
	(void) wattron(acknowledge, A_BOLD);
	(void) wprintw(acknowledge, "bold ");
	(void) wattroff(acknowledge, A_BOLD);
	(void) wprintw(acknowledge, "key representing the menu");
	(void) wmove(acknowledge, (row/3)+4, 1);
	(void) wprintw(acknowledge, "option. Use the");
	(void) wattron(acknowledge, A_BOLD);
        (void) wprintw(acknowledge, " right arrow (->)");
        (void) wattroff(acknowledge, A_BOLD);
	(void) wprintw(acknowledge, " key to select a field/value from the drop-down menu.");
        (void) wmove(acknowledge, (row/2)+3, 1);
	(void) wprintw(acknowledge, "You are currently running LKCP in ");
	(void) wattron(acknowledge, A_BOLD);
	if (lkcp_mode == 0)
		(void) wprintw(acknowledge, "EDIT MODE. ");
	else{
		(void) wprintw(acknowledge, "VIEW MODE. ");
		(void) wattroff(acknowledge, A_BOLD);
		(void) wprintw(acknowledge, "Run LKCP as root to be able to modify the system.");
	}
	(void) wattroff(acknowledge, A_BOLD);
        (void) wmove(acknowledge, row-2, 1);
        (void) wprintw(acknowledge, "This software is still under development. Please send bug reports to ");
	(void) wattron(acknowledge, A_BOLD);
	(void) wprintw(acknowledge, "hyoussef@gmail.com.");
	(void) wattroff(acknowledge, A_BOLD);
        (void) wrefresh(acknowledge);
	LOG_CALL(1);
}

void kill_acknowledge(WINDOW* acknowledge){
        int key;
	LOG_CALL(0);
        while((key=getch())!= ESC){ if (is_term_resized(0,0)) wrefresh(acknowledge);refresh();}

        (void) erase();
	LOG_CALL(1);
}

