#ifndef __COMMIT_SCRIPT_H__
#define __COMMIT_SCRIPT_H__

#include "lkcp.h"

#define MAX_PATH_LEN	512
#define MAX_CMD_LEN	64

typedef struct {
	char path[MAX_PATH_LEN];
	char cmd[MAX_CMD_LEN];
} s_commit;

#define		OUTPUT_HEADER(f)	\
			do{		\
				fprintf(f, "#!/bin/bash\n");	\
				fprintf(f, "# This script was automatically generated by LKCP %s.\n", LKCP_VERSION);	\
				fprintf(f, "# Only the commands that were successfull are the ones that \n"); \
				fprintf(f, "# get put into this script.\n");	\
			}while(0)

#define 	OUTPUT_CHECK_FILE(f)	\
			do{		\
				fprintf(f, "\nif [ -f ");	\
			}while(0)

#define		OUTPUT_PROC_FILENAME(f,v)	\
			do{		\
				fprintf(f, "%s", v);		\
			}while(0)

#define 	OUTPUT_HEADER_CONTINUE(f)	\
			do{			\
				fprintf(f, " ]; then\n");	\
			}while(0)

#define		OUTPUT_ECHO(f)		\
			do{		\
				fprintf(f, "\techo ");		\
			}while(0)

#define		OUTPUT_FIELD_WRITE_VALUE(f,v)	\
			do{	\
				fprintf(f, "\"%s\" ", v);		\
			}while(0)
#define         OUTPUT_PROC_FILENAME_REDIR(f,v)       \
                        do{             \
                                fprintf(f, ">%s;", v);            \
                        }while(0)

#define		OUTPUT_FOOTER(f)	\
			do{		\
				fprintf(f, "\nfi\n");		\
			}while(0)

void log_cmd(const char* path, const char* cmd);
void dump_script(void);
GList* del_dup_cmd(GList* dump_list);
void write_cmd_tofile(GList* dump_list);
void draw_dumpwin(WINDOW* dumpwin);
void draw_dumpban(WINDOW* dumpban);

#endif
