#ifndef __HELP_H__
#define __HELP_H__

#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <errno.h>
#include <string.h>
#include "lkcp.h"

#define MAX_HELP	2000	/* about 200 words */

#define HELP_NAMES	136	/* number of /proc/sys names with available help */

void get_help_subject(const char* name, char* help);
void draw_helpwin(WINDOW* helpwin, const char* name);
void dash2underscore(char* name);
int ishelp(const char* name, char* hold_help_buf);
void serialize_output(WINDOW* help, char* help_buffer, int lines, int columns);

void version(char* help){
	char* temp = "The #n means that this is the nth kernel built from this source base and the date \
after it indicates the time the kernel was built. The only way to tune these values is to rebuild the kernel.";

	strncpy(help, temp, strlen(temp));
}
void panic(char* help){
	char* temp="The value in this file represents the number of seconds the kernel waits \
 before rebooting on a panic. When you use the software watchdog, the recommended setting \
 is 60. If set to 0, the auto reboot after a kernel panic is disabled, which is the default setting.";

	strncpy(help, temp, strlen(temp));
}
void printk(char* help){
	char* temp="The four values in printk denote: console_loglevel, default_message_loglevel, \
minimum_console_loglevel, and default_console_loglevel respectively. These values influence printk() \
behavior when printing or logging error messages, which come from inside the kernel. See \
syslog(2) for more information on the different log levels.";

	 strncpy(help, temp, strlen(temp));
}
void sg_big_buff(char* help){
	char* temp = "This file shows the size of the generic SCSI (sg) buffer. At this point, you \
can't tune it yet, but you can change it at compile time by editing include/scsi/sg.h and \
changing the value of SG_BIG_BUFF. If you use a scanner with SANE (Scanner Access Now Easy) you might \
want to set this to a higher value. Refer to the SANE documentation on this issue.";

	 strncpy(help, temp, strlen(temp));
}
void modprobe(char* help){
	char* temp = "The location where the modprobe binary is located. The kernel uses this \
program to load modules on demand.";
	
	strncpy(help, temp, strlen(temp));
}
void unknown_nmi_panic(char* help){
	char* temp = "The value in this file affects behavior of handling NMI. When the value is \
non-zero, unknown NMI is trapped and then panic occurs. At that time, kernel debugging information \
is displayed on console.";
	
	strncpy(help, temp, strlen(temp));
}
void dentry_state(char* help){
	char* temp="Status of the directory cache. Since directory entries are dynamically \
allocated and deallocated, this file indicates the current status. It holds \
six values, in which the last two are not used and are always zero.";

	strncpy(help, temp, strlen(temp));
}
void dquot_nr(char* help){
	char* temp="The file dquot-nr shows the number of allocated disk quota entries and the \
number of free disk quota entries. If the number of available cached disk quotas is very low and \
you have a large number of simultaneous system users, you might want to raise the limit.";

	strncpy(help, temp, strlen(temp));
}
void dquot_max(char* help){
	char* temp="The file dquot-max shows the maximum number of cached disk quota entries. \
If the number of available cached disk quotas is very low and you have a large number of simultaneous \
system users, you might want to raise the limit.";

	strncpy(help, temp, strlen(temp));
}
void queues_max(char* help){
	char* temp = "/proc/sys/fs/mqueue/queues_max is a read/write file for setting/getting the \
maximum number of message queues allowed on the system.";
	
	strncpy(help, temp, strlen(temp));
}
void msg_max(char* help){
	char* temp = "is a read/write file for setting/getting the maximum number of messages in a \
queue value. In fact it is the limiting value for another (user) limit which is set in mq_open invocation. \
This attribute of a queue must be less or equal then msg_max.";

	strncpy(help, temp, strlen(temp));
}
void msgsize_max(char* help){
	char* temp = "is a read/write file for setting/getting the maximum message size value \
(it is every message queue's attribute set during its creation).";
	
	strncpy(help, temp, strlen(temp));
} 
void ipx_route(char* help){
	char* temp = "table holds a list of IPX routes. For each route it gives the destination \
network, the router node (or Directly) and the network address of the router (or Connected) for \
internal networks.";
	
	strncpy(help, temp, strlen(temp));
}
void ipx_interface(char* help){
	char* temp = " file lists all IPX interfaces. For each interface it gives the network number, \
the node number, and indicates if the network is the primary network. It also indicates which device \
it is bound to (or Internal for internal networks) and the Frame Type if appropriate. Linux \
supports 802.3, 802.2, 802.2 SNAP and DIX (Blue Book) ethernet framing for IPX.";

	strncpy(help, temp, strlen(temp));
}
void aarp_expiry_time(char* help){
	char* temp = "The amount of time we keep an ARP entry before expiring it. Used to age out \
old hosts.";
	
	strncpy(help, temp, strlen(temp));
}
void aarp_tick_time(char* help){
	char* temp = "Controls the rate at which expires are checked.";
	
	strncpy(help, temp, strlen(temp));
}
void aarp_retransmit_limit(char* help){
	char* temp = "The number of times we will retransmit a query before giving up.";
	
	strncpy(help, temp, strlen(temp));
}
void aarp_resolve_time(char* help){
	char* temp = "The amount of time we will spend trying to resolve an Appletalk address.";
		
	strncpy(help, temp, strlen(temp));
}
void atalk_iface(char* help){
	char* temp = "lists all the interfaces configured for appletalk. It shows the name of the \
interface, its Appletalk address, the network range on that address(or network number for phase 1 networks), \
and the status of the interface.";
	
	strncpy(help, temp, strlen(temp));
}
void atalk_route(char* help){
	char* temp = "lists each known network route. It lists the target(network) that the route leads to, \
the router (may be directly connected), the route flags, and the device the route is using.";

	strncpy(help, temp, strlen(temp));
}
void gc_stale_time(char* help){
	char* temp = "Determines how often to check for stale ARP entries. After an ARP entry is stale it will \
be resolved again(which is useful when an IP address migrates to another machine). When ucast_solicit is \
greater than 0 it first tries to send an ARP packet directly to the known host When that fails and mcast_solicit \
is greater than 0, an ARP request is broadcasted.";
	
	strncpy(help, temp, strlen(temp));
}

void app_solicit(char* help){
	char* temp = "Determines the number of requests to send to the user level ARP daemon. Use 0 to turn off.";
	
	strncpy(help, temp, strlen(temp));
}
void proxy_qlen(char* help){
	char* temp = "Maximum queue length of the delayed proxy arp timer. (see proxy_delay).";

	strncpy(help, temp, strlen(temp));
}
void proxy_delay(char* help){
	char* temp = "Maximum time (real time is random [0..proxytime]) before answering to an ARP request for \
which we have an proxy ARP entry. In some cases, this is used to prevent network flooding.";
	
	strncpy(help, temp, strlen(temp));
}
void locktime(char* help){
	char* temp = "An ARP/neighbor entry is only replaced with a new one if the old is at least locktime old. \
This prevents ARP cache thrashing.";

	strncpy(help, temp, strlen(temp));
}
void delay_first_probe_time(char* help){
	char* temp = "Delay for the first time probe if the neighbor is reachable.(see gc_stale_time).";
	
	strncpy(help, temp, strlen(temp));
}
void mcast_solicit(char* help){
	char* temp = "Maximum number of retries for multicast solicitation.";

	strncpy(help, temp, strlen(temp));
}
void ucast_solicit(char* help){
	char* temp = "Maximum number of retries for unicast solicitation.";

	strncpy(help, temp, strlen(temp));
}
void anycast_delay(char* help){
	char* temp = "Maximum for random delay of answers to neighbor solicitation messages in jiffies \
(1/100 sec). Not yet implemented (Linux does not have anycast support yet).";

	strncpy(help, temp, strlen(temp));
}
void unres_qlen(char* help){
	char* temp = "Maximum queue length for a pending arp request - the number of packets which are accepted \
from other layers while the ARP address is still resolved.";

	strncpy(help, temp, strlen(temp));
}
void retrans_time(char* help){
	char* temp = "The time, expressed in jiffies (1/100 sec), between retransmitted Neighbor Solicitation \
messages. Used for address resolution and to determine if a neighbor is unreachable.";

	strncpy(help, temp, strlen(temp));
}
void base_reachable_time(char* help){
	char* temp = "A base value used for computing the random reachable time value as specified in RFC2461.";
	
	strncpy(help, temp, strlen(temp));
}
void redirect_silence(char* help){
	char* temp = "Timeout for redirects. After this period redirects will be sent again, even if this has been \
stopped, because the load or number limit has been reached.";

	strncpy(help, temp, strlen(temp));
}
void redirect_load(char* help){
	char* temp = "Factors which determine if more ICPM redirects should be sent to a specific host. No \
redirects will be sent once the load limit or the maximum number of redirects has been reached.";

	strncpy(help, temp, strlen(temp));
}
void redirect_number(char* help){
	char* temp = "Factors which determine if more ICPM redirects should be sent to a specific host. No \
redirects will be sent once the load limit or the maximum number of redirects has been reached.";

	strncpy(help, temp, strlen(temp));
}
void max_delay(char* help){
	char* temp = "Delays for flushing the routing cache.";

	strncpy(help, temp, strlen(temp));
}
void min_delay(char* help){
	char* temp = "Delays for flushing the routing cache.";

	strncpy(help, temp, strlen(temp));
}
void max_size(char* help){
	char* temp = "Maximum size of the routing cache. Old entries will be purged once the cache reached \
has this size.";

	strncpy(help, temp, strlen(temp));
}
void gc_elasticity(char* help){
	char* temp = "Values to control the frequency and behavior of the garbage collection algorithm for the \
routing cache. gc_min_interval is deprecated and replaced by gc_min_interval_ms.";
	
	strncpy(help, temp, strlen(temp));
}
void gc_interval(char* help){
	gc_elasticity(help);
}
void gc_min_interval_ms(char* help){
	gc_elasticity(help);
}
void gc_timeout(char* help){
	gc_elasticity(help);
}
void gc_tresh(char* help){
	gc_elasticity(help);
}
void flush(char* help){
	char* temp = "Writing to this file results in a flush of the routing cache.";
	
	strncpy(help, temp, strlen(temp));
}
void error_burst(char* help){
	char* temp = "These parameters are used to limit how many ICMP destination unreachable to send from \
the host in question. ICMP destination unreachable messages are sent when we can not reach the next hop, while \
trying to transmit a packet. It will also print some error messages to kernel logs if someone is ignoring our ICMP \
redirects.";

	strncpy(help, temp, strlen(temp));
}
void error_cost(char* help){
	char* temp = "The higher the error_cost factor is, the fewer destination unreachable and error messages will \
be let through. Error_burst controls when destination unreachable messages and error messages will be dropped. \
The default settings limit warning messages to five every second.";

	strncpy(help, temp, strlen(temp));
}
void send_redirects(char* help){
	char* temp = "Determines whether to send ICMP redirects to other hosts.";
	
	strncpy(help, temp, strlen(temp));
}
void shared_media(char* help){
	char* temp = "If it is not set the kernel does not assume that different subnets on this device can \
communicate directly. Default setting is 'yes'.";

	strncpy(help, temp, strlen(temp));
}
void secure_redirects(char* help){
	char* temp = "Accept ICMP redirect messages only for gateways, listed in default gateway list. Enabled \
by default.";

	strncpy(help, temp, strlen(temp));
}
void rp_filter(char* help){
	char* temp = "Integer value determines if a source validation should be made. 1 means yes, 0 means no. \
Disabled by default, but local/broadcast address spoofing is always on. If you set this to 1 on a router that is \
the only connection for a network to the net, it will prevent spoofing attacks against your internal networks \
(external addresses can still be spoofed), without the need for additional firewall rules.";

	strncpy(help, temp, strlen(temp));
}
void proxy_arp(char* help){
	char* temp = "Does (1) or does not (0) perform proxy ARP.";

	strncpy(help, temp, strlen(temp));
}
void mc_forwarding(char* help){
	char* temp = "Do multicast routing. The kernel needs to be compiled with CONFIG_MROUTE and a multicast \
routing daemon is required.";

	strncpy(help, temp, strlen(temp));
}
void log_martians(char* help){
	char* temp = "Log packets with source addresses with no known route to kernel log.";

	strncpy(help, temp, strlen(temp));
}
void forwarding(char* help){
	char* temp = "Enable or disable IP forwarding on this interface.";
	
	strncpy(help, temp, strlen(temp));
}
void bootp_relay(char* help){
	char* temp = "Accept packets with source address 0.b.c.d with destinations not to this host as local \
ones. It is supposed that a BOOTP relay daemon will catch and forward such packets. The default is 0, since this \
feature is not implemented yet (kernel version 2.2.12).";

	strncpy(help, temp, strlen(temp));
}
void accept_source_route(char* help){
	char* temp = "Should source routed packages be accepted or declined. The default is dependent on the kernel \
configuration. It's 'yes' for routers and 'no' for hosts.";

	strncpy(help, temp, strlen(temp));
}
void accept_redirects(char* help){
	char* temp = "This switch decides if the kernel accepts ICMP redirect messages or not. The default is \
'yes' if the kernel is configured for a regular host and 'no' for a router configuration.";
	
	strncpy(help, temp, strlen(temp));
}
void tcp_retries2(char* help){
	char* temp = "Defines how often a TCP packet is retransmitted before giving up.";
	
	strncpy(help, temp, strlen(temp));
}
void tcp_retries1(char* help){
	char* temp = "Defines how often an answer to a TCP connection request is retransmitted before giving up.";

	strncpy(help, temp, strlen(temp));
}
void tcp_max_syn_blacklog(char* help){
	char* temp = "Length of the per socket backlog queue. Since Linux 2.2 the backlog specified in listen(2) \
only specifies the length of the backlog queue of already established sockets. When more connection requests arrive \
Linux starts to drop packets. When syncookies are enabled the packets are still answered and the maximum queue is \
effectively ignored.";

	strncpy(help, temp, strlen(temp));
}
void tcp_max_ka_probes(char* help){
	char* temp = "Indicates how many keep alive probes are sent per slow timer run. Should not be set too high \
 to prevent bursts.";

	strncpy(help, temp, strlen(temp));
}
void tcp_fin_timeout(char* help){
	char* temp = "The length of time in seconds it takes to receive a final FIN before the socket is always closed.\
 This is strictly a violation of the TCP specification, but required to prevent denial-of-service attacks.";

	strncpy(help, temp, strlen(temp));
}
void tcp_window_scaling(char* help){
	char* temp = "Enable window scaling as defined in RFC1323.";

	strncpy(help, temp, strlen(temp));
}
void tcp_syncookies(char* help){
	char* temp = "Only valid when the kernel was compiled with CONFIG_SYNCOOKIES. Send out syncookies when the syn \
backlog queue of a socket overflows. This is to ward off the common 'syn flood attack'. Disabled by default. Note that \
the concept of a socket backlog is abandoned. This means the peer may not receive reliable error messages from \
an over loaded server with syncookies enabled.";

	strncpy(help, temp, strlen(temp));
}
void tcp_stdurg(char* help){
	char* temp = "Enable the strict RFC793 interpretation of the TCP urgent pointer field. The default is to use the \
BSD compatible interpretation of the urgent pointer pointing to the first byte after the urgent data. The RFC793 \
interpretation is to have it point to the last byte of urgent data. Enabling this option may lead to interoperatibility \
problems. Disabled by default.";

	strncpy(help, temp, strlen(temp));
}
void tcp_timestamps(char* help){
	char* temp = "Enable timestamps as defined in RFC1323.";

	strncpy(help, temp, strlen(temp));
}
void tcp_sack(char* help){
	char* temp = "Enable select acknowledgments after RFC2018.";

	strncpy(help, temp, strlen(temp));
}
void tcp_syn_retries(char* help){
	char* temp = "Number of times initial SYNs for a TCP connection attempt will be retransmitted. Should not be higher \
than 255. This is only the timeout for outgoing connections, for incoming connections the number of retransmits is defined by \
tcp_retries1.";

	strncpy(help, temp, strlen(temp));
}
void tcp_keepalive_time(char* help){
	char* temp = "How often TCP sends out keep alive messages, when keep alive is enabled. The default is 2 hours.";

	strncpy(help, temp, strlen(temp));
}
void tcp_keepalive_probes(char* help){
	char* temp = "Number of keep alive probes TCP sends out, until it decides that the connection is broken.";

	strncpy(help, temp, strlen(temp));
}
void tcp_retrans_collapse(char* help){
	char* temp = "Bug-to-bug compatibility with some broken printers. On retransmit, try to send larger packets to work \
around bugs in certain TCP stacks. Can be turned off by setting it to zero.";

	strncpy(help, temp, strlen(temp));
}
void tcp_ecn(char* help){
	char* temp = "This file controls the use of the ECN bit in the IPv4 headers, this is a new feature about Explicit \
Congestion Notification, but some routers and firewalls block trafic that has this bit set, so it could be necessary to echo 0 to \
/proc/sys/net/ipv4/tcp_ecn, if you want to talk to this sites. For more info you could read RFC2481.";

	strncpy(help, temp, strlen(temp));
}
void ipfrag_time(char* help){
	char* temp = "Time in seconds to keep an IP fragment in memory.";

	strncpy(help, temp, strlen(temp));
}
void ipfrag_high_trash(char* help){
	char* temp = "Maximum memory used to reassemble IP fragments. When ipfrag_high_thresh bytes of memory is allocated for this \
purpose, the fragment handler will toss packets until ipfrag_low_thresh is reached.";

	strncpy(help, temp, strlen(temp));
}
void ipfrag_low_trash(char* help){
	ipfrag_high_trash(help);
}
void ip_masq_debug(char* help){
	char* temp = "Enable/disable debugging of IP masquerading.";
	
	strncpy(help, temp, strlen(temp));
}
void ip_no_pmtu_disc(char* help){
	char* temp = "Global switch to turn path MTU discovery off. It can also be set on a per socket basis by the applications \
or on a per route basis.";

	strncpy(help, temp, strlen(temp));
}
void ip_local_port_range(char* help){
	char* temp = "Range of ports used by TCP and UDP to choose the local port. Contains two numbers, the first number is the lowest \
port, the second number the highest local port. Default is 1024-4999. Should be changed to 32768-61000 for high-usage systems.";

	strncpy(help, temp, strlen(temp));
}
void ip_forward(char* help){
	char *temp = "Enable or disable forwarding of IP packages between interfaces. Changing this value resets all other parameters to \
their default values. They differ if the kernel is configured as host or router.";

	strncpy(help, temp, strlen(temp));
}
void dynaddr(char* help){
	char* temp = "Enable dynamic socket address rewriting on interface address change. This is useful for dialup interface with \
changing IP addresses.";

	strncpy(help, temp, strlen(temp));
}
void ip_default_ttl(char* help){
	char* temp = "TTL (Time To Live) for IPv4 interfaces. This is simply the maximum number of hops a packet may travel.";

	strncpy(help, temp, strlen(temp));
}
void ip_autoconfig(char* help){
	char* temp = "This file contains the number one if the host received its IP configuration by RARP, BOOTP, DHCP or a similar \
mechanism. Otherwise it is zero.";

	strncpy(help, temp, strlen(temp));
}
void icmp_destunreach_rate(char* help){
	char* temp = "sets limits for sending ICMP packets to specific targets. A value of zero disables all limiting. Any positive value \
sets the maximum package rate in hundredth of a second (on Intel systems).";

	strncpy(help, temp, strlen(temp));
}
void icmp_echoreply_rate(char* help){
	icmp_destunreach_rate(help);
}
void icmp_paramprob_rate(char* help){
	icmp_destunreach_rate(help);
}
void icmp_timeexeed_rate(char* help){
	icmp_destunreach_rate(help);
}
void icmp_echo_ignore_all(char* help){
	char* temp = "Turn on (1) or off (0), if the kernel should ignore all ICMP ECHO requests, or just those to broadcast and multicast \
addresses. Please note that if you accept ICMP echo requests with a broadcast/multi-cast destination address your network may be used as \
an exploder for denial of service packet flooding attacks to other hosts.";

	strncpy(help, temp, strlen(temp));
}
void icmp_echo_ignore_broadcasts(char* help){
	icmp_echo_ignore_all(help);
}
void optmem_max(char* help){
	char* temp ="Maximum ancillary buffer size allowed per socket. Ancillary data is a sequence of struct cmsghdr structures with \
appended data.";

	strncpy(help, temp, strlen(temp));
}
void netdev_max_backlog(char* help){
	char* temp ="Maximum number of packets, queued on the INPUT side, when the interface receives packets faster than kernel can \
process them.";

	strncpy(help, temp, strlen(temp));
}
void message_burst(char* help){
	char *temp = "These parameters are used to limit the warning messages written to the kernel log from the networking code. They \
enforce a rate limit to make a denial-of-service attack impossible. A higher message_cost factor, results in fewer messages that will be \
written. Message_burst controls when messages will be dropped. The default settings limit warning messages to one every five seconds.";

	strncpy(help, temp, strlen(temp));
}
void message_cost(char* help){
	message_burst(help);
}
void wmem_max(char* help){
	char* temp ="The maximum send socket buffer size in bytes.";

	strncpy(help, temp, strlen(temp));
}
void wmem_default(char* help){
	char* temp = "The default setting (in bytes) of the socket send buffer.";

	strncpy(help, temp, strlen(temp));
}
void rmem_max(char* help){
	char* temp = "The maximum receive socket buffer size in bytes.";

	strncpy(help, temp, strlen(temp));
}
void rmem_default(char* help){
	char* temp = "The default setting of the socket receive buffer in bytes.";

	strncpy(help, temp, strlen(temp));
}
void nfs_debug(char* help){
	char* temp = "This directory contains four files, which enable or disable debugging for the RPC functions NFS, NFS-daemon, RPC \
and NLM. The default values are 0. They can be set to one to turn debugging on. (The default value is 0 for each).";

	strncpy(help, temp, strlen(temp));
}
void nfsd_debug(char* help){
	nfs_debug(help);
}
void nlm_debug(char* help){
	nfs_debug(help);
}
void rpc_debug(char* help){
	nfs_debug(help);
}
void swap_token_timeout(char* help){
	char* temp = "This file contains valid hold time of swap out protection token. The Linux VM has token based thrashing control \
mechanism and uses the token to prevent unnecessary page faults in thrashing situation. The unit of the value is second. The value would \
be useful to tune thrashing behavior.";

	strncpy(help, temp, strlen(temp));
}
void block_dump(char* help){
	char* temp = "enables block I/O debugging when set to a nonzero value. More information on block I/O debugging is in \
Documentation/laptop-mode.txt.";

	strncpy(help, temp, strlen(temp));
}
void laptop_mode(char* help){
	char* temp = "is a knob that controls \"laptop mode\". All the things that are controlled by this knob are discussed in \
Documentation/laptop-mode.txt.";

	strncpy(help, temp, strlen(temp));
}
void nr_hugepages(char* help){
	char* temp = "configures number of hugetlb page reserved for the system.";

	strncpy(help, temp, strlen(temp));
}
void hugetlb_shm_group(char* help){
	char* temp = "contains group id that is allowed to create SysV shared.";

	strncpy(help, temp, strlen(temp));
}
void overcommit_memory(char* help){
	char* temp = "This file contains one value. The following algorithm is used to decide if there's enough memory: if the value of \
overcommit_memory is positive, then there's always enough memory. This is a useful feature, since programs often malloc() huge amounts \
of memory 'just in case', while they only use a small part of it. Leaving this value at 0 will lead to the failure of such a huge malloc(), \
when in fact the system has enough memory for the program to run. On the other hand, enabling this feature can cause you to run out of memory \
and thrash the system to death, so large and/or important servers will want to set this value to 0. memory segment using hugetlb page.";

	strncpy(help, temp, strlen(temp));
}
void page_cluster(char* help){
	char* temp = "page-cluster controls the number of pages which are written to swap in a single attempt. The swap I/O size. It is a \
logarithmic value - setting it to zero means \"1 page\", setting it to 1 means \"2 pages\", setting it to 2 means \"4 pages\", etc. The default \
value is three (eight pages at a time). There may be some small benefits in tuning this to a different value if your workload is swap-intensive.";

	strncpy(help, temp, strlen(temp));
} 
void lower_zone_protection(char* help){
	char* temp = "The `lower_zone_protection' tunable determines how aggressive the kernel is in defending these lower zones. The default \
value is zero - no protection at all. Read Documentation/filesystem/proc.txt for more details.";

	strncpy(help, temp, strlen(temp));
}
void legacy_va_layout(char* help){
	char* temp = "If non-zero, this sysctl disables the new 32-bit mmap mmap layout - the kernel will use the legacy (2.4) layout for \
all processes.";

	strncpy(help, temp, strlen(temp));
}
void dirty_expire_centisecs(char* help){
	char* temp = "This tunable is used to define when dirty data is old enough to be eligible for writeout by the pdflush daemons. It is \
expressed in 100'ths of a second. Data which has been dirty in-memory for longer than this interval will be written out next time a pdflush \
daemon wakes up.";

	strncpy(help, temp, strlen(temp));
}
void dirty_writeback_centisecs(char* help){
	char* temp = "The pdflush writeback daemons will periodically wake up and write `old' data out to disk. This tunable expresses the \
interval between those wakeups, in 100'ths of a second. Setting this to zero disables periodic writeback altogether.";

	strncpy(help, temp, strlen(temp));
}
void dirty_ratio(char* help){
	char* temp = "Contains, as a percentage of total system memory, the number of pages at which a process which is generating disk \
writes will itself start writing out dirty data.";

	strncpy(help, temp, strlen(temp));
}
void dirty_background_ratio(char* help){
	char* temp = "Contains, as a percentage of total system memory, the number of pages at which the pdflush background writeback daemon \
will start writing out dirty data.";

	strncpy(help, temp, strlen(temp));
}
void vfs_cache_pressure(char* help){
	char* temp = "Controls the tendency of the kernel to reclaim the memory which is used for caching of directory and inode objects. At \
the default value of vfs_cache_pressure=100 the kernel will attempt to reclaim dentries and inodes at a \"fair\" rate with respect to pagecache \
and swapcache reclaim. Decreasing vfs_cache_pressure causes the kernel to prefer to retain dentry and inode caches. Increasing \
vfs_cache_pressure beyond 100 causes the kernel to prefer to reclaim dentries and inodes.";

	strncpy(help, temp, strlen(temp));
}
void minimum_console_loglevel(char* help){
	char* temp = "Minimum (highest) value to which the console_loglevel can be set.";

	strncpy(help, temp, strlen(temp));
}
void default_message_level(char* help){
	char* temp = "Messages without an explicit priority will be printed with this priority.";

	strncpy(help, temp, strlen(temp));
}
void console_loglevel(char* help){
	char* temp = "Messages with a higher priority than this will be printed to the console.";

	strncpy(help, temp, strlen(temp));
}
void ctrl_alt_del(char* help){
	char* temp = "When the value in this file is 0, ctrl-alt-del is trapped and sent to the init program to handle \
a graceful restart. However, when the value is greater that zero, Linux's reaction to this key combination will be an \
immediate reboot, without syncing its dirty buffers.";

	strncpy(help, temp, strlen(temp));
}
void acctn(char* help){
	char* temp = " The file contains three values; highwater, lowwater, and frequency. It exists only when BSD-style process \
accounting is enabled. These values control its behavior. If the free space on the file system where the log lives goes below \
lowwater percentage, accounting suspends. If it goes above highwater percentage, accounting resumes. Frequency determines how \
often you check the amount of free space (value is in seconds). Default settings are: 4, 2, and 30. That is, suspend accounting \
if there is less than 2 percent free; resume it if we have a value of 3 or more percent; consider information about the amount of \
free space valid for 30 seconds.";

	strncpy(help, temp, strlen(temp));
}
void file_nr(char* help){
	char* temp = "The kernel allocates file handles dynamically, but doesn't free them again at this time.";

	strncpy(help, temp, strlen(temp));
}
void file_max(char* help){
	char* temp = "The value in file-max denotes the maximum number of file handles that the Linux kernel will allocate. When \
you get a lot of error messages about running out of file handles, you might want to raise this limit. The default value is \
10% of RAM in kilobytes. To change it, just write the new number into the file.";

	strncpy(help, temp, strlen(temp));
}
void inode_state(char* help){
	char* temp = "contains two actual numbers and five dummy values. The numbers are nr_inodes and nr_free_inodes (in order of appearance).";

	strncpy(help, temp, strlen(temp));
}
void inode_nr(char* help){
	char* temp = "contains the first two items from inode-state, so we'll skip to that file.";
	
	strncpy(help, temp, strlen(temp));
}
void nr_inodes(char* help){
	char* temp = "Denotes the number of inodes the system has allocated. This number will grow and shrink dynamically.";

	strncpy(help , temp, strlen(temp));
}
void nr_free_inodes(char* help){
	char* temp = "Represents the number of free inodes. Ie. The number of inuse inodes is (nr_inodes - nr_free_inodes).";

	strncpy(help, temp, strlen(temp));
}
void super_max(char* help){
	char* temp = "Again, super block structures are allocated by the kernel, but not freed. The file super-max contains the \
maximum number of super block handlers, where super-nr shows the number of currently allocated ones. Every mounted file system needs \
a super block, so if you plan to mount lots of file systems, you may want to increase these numbers.";

	strncpy(help, temp, strlen(temp));
}
void super_nr(char* help){
	super_max(help);
}
void aio_nr(char* help){
	char* temp = "aio-nr is the running total of the number of events specified on the io_setup system call for all currently \
active aio contexts. If aio-nr reaches aio-max-nr then io_setup will fail with EAGAIN. Note that raising aio-max-nr does not \
result in the pre-allocation or re-sizing of any kernel data structures.";

	strncpy(help, temp, strlen(temp));
}
void aio_max_nr(char* help){
	aio_nr(help);
}
void bdflush(char* help){
	char* temp = "The bdflush file contains 9 parameters, of which 6 are tunable. These parameters affect the rate at which \
pages in the buffer cache are freed and returned to disk.  By adjusting the various values in this file, a system can be tuned to \
achieve better performance in environments where large amounts of file I/O are performed. Generally, systems that require more free \
memory for application allocation will want to set these values higher.";

	strncpy(help, temp, strlen(temp));
}
void dcache_priority(char* help){
	char* temp = "This file controls the bias of the priority for caching directory contents. When the system is under stress, it \
will selectively reduce the size of various file system caches in an effort to reclaim memory. By adjusting this value up, memory \
reclamation bias is shifted away from the dirent cache. By reducing this amount bias is shifted toward reclaiming dirent memory. This \
is not a particularly useful.";

	strncpy(help, temp, strlen(temp));
}
void hugetlb_pool(char* help){
	char* temp = "This file is responsible for recording the number of megabytes used for `huge' pages. Huge pages are just like \
regular pages in the VM, only they are an order of magnitude larger . Hugepages are both beneficial and detrimental to a system.";
	
	strncpy(help, temp, strlen(temp));
}

void inactive_clean_percent(char* help){
	char* temp = "This control specifies the minimum percentage of pages in each page zone that must be in the clean or laundered \
state. If any zone drops below this threshold, and the system is under pressure for more memory, then that zone will begin having its \
inactive dirty pages laundered.";

	strncpy(help, temp, strlen(temp));
}
void kswapd(char* help){
	char* temp = "This set of parameters defines how frequently and in what volume a system moved non buffer cache pages to disk.";
	
	strncpy(help, temp, strlen(temp));
}
void max_map_count(char* help){
	char* temp = "This file allows for the restriction of the number of VMAs6 that a particular process can own. A Virtual memory \
area is a contiguous area of virtual address space.";

	strncpy(help, temp, strlen(temp));
}
void nr_pdflush_threads(char* help){
	char* temp = "It represents the count of currently-running pdflush threads. Pdflush threads are worker threads responsible for "
			"writing back dirty data.";

	strncpy(help, temp, strlen(temp));
}
#endif
