/*
-----------------------------------------------------------
 Copyright (c) Youssef Hmamouche - All Rights Reserved.

 This software is subject to the General Public License.
 ----------------------------------------------------------
*/

#include "help.h"
#include "dbg.h"

/*
 PFN type
*/
typedef void (*PFN)(char* help);

#ifdef DEBUG
extern FILE* f;
#endif

/*
 Declare and initialize an array of character pointers
*/

PFN pfn[HELP_NAMES] = {version, panic, printk, sg_big_buff, modprobe, unknown_nmi_panic, dentry_state, dquot_nr, \
dquot_max, queues_max, msg_max, msgsize_max, ipx_route, ipx_interface, aarp_expiry_time, aarp_tick_time, aarp_retransmit_limit, \
aarp_resolve_time, atalk_iface, atalk_route, gc_stale_time, app_solicit, proxy_qlen, proxy_delay, locktime, delay_first_probe_time, \
 mcast_solicit, ucast_solicit, anycast_delay, unres_qlen, retrans_time, base_reachable_time, redirect_silence, redirect_load, \
redirect_number, max_delay, min_delay, max_size, gc_elasticity, gc_interval, gc_min_interval_ms, gc_timeout, gc_tresh, flush, error_burst, \
error_cost, send_redirects, shared_media, secure_redirects, rp_filter, proxy_arp, mc_forwarding, log_martians, forwarding, bootp_relay, \
accept_source_route, accept_redirects, tcp_retries2, tcp_retries1, tcp_max_syn_blacklog, tcp_max_ka_probes, tcp_fin_timeout, \
tcp_window_scaling, tcp_syncookies, tcp_stdurg, tcp_timestamps, tcp_sack, tcp_syn_retries, tcp_keepalive_time, tcp_keepalive_probes, \
tcp_retrans_collapse, tcp_ecn, ipfrag_time, ipfrag_high_trash, ipfrag_low_trash, ip_masq_debug, ip_no_pmtu_disc, ip_local_port_range, \
ip_forward, dynaddr, ip_default_ttl, ip_autoconfig, icmp_destunreach_rate, icmp_echoreply_rate, icmp_paramprob_rate, icmp_timeexeed_rate, \
icmp_echo_ignore_all, icmp_echo_ignore_broadcasts, optmem_max, netdev_max_backlog, message_burst, message_cost, wmem_max, wmem_default, rmem_max, \
rmem_default, nfs_debug, nfsd_debug, nlm_debug, rpc_debug, swap_token_timeout, block_dump, laptop_mode, nr_hugepages, hugetlb_shm_group, \
overcommit_memory, page_cluster, lower_zone_protection, legacy_va_layout, dirty_expire_centisecs, dirty_writeback_centisecs, dirty_ratio, \
dirty_background_ratio, vfs_cache_pressure, minimum_console_loglevel, default_message_level, console_loglevel, ctrl_alt_del, acctn, file_nr, \
file_max, inode_state, inode_nr, nr_inodes, nr_free_inodes, super_max, super_nr, aio_nr, aio_max_nr, bdflush, dcache_priority, hugetlb_pool, \
inactive_clean_percent, kswapd, max_map_count, nr_pdflush_threads};

char* map[HELP_NAMES] = {"version", "panic", "printk", "sg_big_buff", "modprobe", "unknown_nmi_panic", "dentry_state", "dquot_nr", \
"dquot_max", "queues_max", "msg_max", "msgsize_max", "ipx_route", "ipx_interface", "aarp_expiry_time", "aarp_tick_time", "aarp_retransmit_limit", \
"aarp_resolve_time", "atalk_iface", "atalk_route", "gc_stale_time", "app_solicit", "proxy_qlen", "proxy_delay", "locktime", "delay_first_probe_time", \
"mcast_solicit", "ucast_solicit", "anycast_delay", "unres_qlen", "retrans_time", "base_reachable_time", "redirect_silence", "redirect_load", \
"redirect_number", "max_delay", "min_delay", "max_size", "gc_elasticity", "gc_interval", "gc_min_interval_ms", "gc_timeout", "gc_tresh", "flush", \
"error_burst", "error_cost", "send_redirects", "shared_media", "secure_redirects", "rp_filter", "proxy_arp", "mc_forwarding", "log_martians", \
"forwarding", "bootp_relay", "accept_source_route", "accept_redirects", "tcp_retries2", "tcp_retries1", "tcp_max_syn_blacklog", "tcp_max_ka_probes", \
"tcp_fin_timeout", "tcp_window_scaling", "tcp_syncookies", "tcp_stdurg", "tcp_timestamps", "tcp_sack", "tcp_syn_retries", "tcp_keepalive_time", \
"tcp_keepalive_probes", "tcp_retrans_collapse", "tcp_ecn", "ipfrag_time", "ipfrag_high_trash", "ipfrag_low_trash", "ip_masq_debug", "ip_no_pmtu_disc", \
"ip_local_port_range", "ip_forward", "dynaddr", "ip_default_ttl", "ip_autoconfig", "icmp_destunreach_rate", "icmp_echoreply_rate", "icmp_paramprob_rate", \
"icmp_timeexeed_rate", "icmp_echo_ignore_all", "icmp_echo_ignore_broadcasts", "optmem_max", "netdev_max_backlog", "message_burst", "message_cost", \
"wmem_max", "wmem_default", "rmem_max", "rmem_default", "nfs_debug", "nfsd_debug", "nlm_debug", "rpc_debug", "swap_token_timeout", "block_dump", \
"laptop_mode", "nr_hugepages", "hugetlb_shm_group", "overcommit_memory", "page_cluster", "lower_zone_protection", "legacy_va_layout", "dirty_expire_centisecs", \
"dirty_writeback_centisecs", "dirty_ratio", "dirty_background_ratio", "vfs_cache_pressure", "minimum_console_loglevel", "default_message_level", \
"console_loglevel", "ctrl_alt_del", "acctn", "file_nr", "file_max", "inode_state", "inode_nr", "nr_inodes", "nr_free_inodes", "super_max", "super_nr", \
"aio_nr", "aio_max_nr", "bdflush", "dcache_priority", "hugetlb_pool", "inactive_clean_percent", "kswapd", "max_map_count", "nr_pdflush_threads"};

void draw_helpwin(WINDOW* helpwin, const char* name){
	char* help_buffer = (char*) malloc(MAX_HELP+1);
	LOG_CALL(0);
	if(help_buffer == NULL){
		LOG_CALL(1);
		return;
	}
	
	memset(help_buffer, '\0', MAX_HELP+1);
	
	get_help_subject(name, help_buffer);

        wbkgd(helpwin, COLOR_PAIR(12));
        (void) wmove(helpwin, 1, 1);
        (void) wprintw(helpwin, "%s: ", name);
	(void) wmove(helpwin, 2, 2);	/* output character by ch to avoid overwriting the box */
	serialize_output(helpwin, help_buffer, 13, 91);
	(void) box(helpwin, ACS_VLINE, ACS_HLINE);	
	(void) doupdate();
	(void) wrefresh(helpwin);		
	(void) refresh();
	
	sfree(help_buffer);
	LOG_CALL(1);
}	
	
void get_help_subject(const char* name, char* help_buffer){

	char* hold_help_buf = (char*) malloc(MAX_HELP+1);
        char* temp_name = (char*) malloc(100+1);
        char* err=NULL;
	LOG_CALL(0);
	if(temp_name ==NULL || hold_help_buf == NULL){
		LOG_CALL(1);
		return;
	}

	memset(temp_name, '\0', 100+1);	
	memset(hold_help_buf, '\0', MAX_HELP+1);

	strncpy(temp_name, name, 100);

	if((err=memchr(temp_name, '-', strlen(temp_name)))!=NULL) /* replace dash withunderscore if it exists */
		dash2underscore(temp_name);
	
	if(ishelp(temp_name, hold_help_buf) < 0){
		strcpy(help_buffer, "No help is available for this field. If you can document this field, \
please take some time to submit it to the developer.");
		sfree(temp_name);
		sfree(hold_help_buf);
		LOG_CALL(1);	
		return;
	}
	strncpy(help_buffer, hold_help_buf, strlen(hold_help_buf));

	sfree(temp_name);
	sfree(hold_help_buf);
	LOG_CALL(1);
}

void dash2underscore(char* name){

	int i=strlen(name);
        char* temp_name = (char*) malloc(i+1);
	LOG_CALL(0);	
	if(temp_name==NULL){
		LOG_CALL(1);
                return;
	}

	memset(temp_name, '\0', i+1);
	strncpy(temp_name, name, i);	
	
	do{
		if(*temp_name == '-')
			*temp_name= '_';
		temp_name++;	
	} 
	while(i-- != 0);
	i=0;	
	do{
		temp_name--;
		i++;
	} while(i !=strlen(name));
	temp_name--;
	strncpy(name, temp_name, strlen(name)); /* dangerous but necessary */

	sfree(temp_name);
			
	LOG_CALL(1); 
}

int ishelp(const char* name, char* hold_help_buf){
	
	register int i;
	LOG_CALL(0);
	for(i=0; i< HELP_NAMES;i++){
                
		if(strcmp(name, map[i])==0){
			pfn[i](hold_help_buf); 
			LOG_CALL(1);
			return 1;
                }
        }

	LOG_CALL(1);
	return -1;
}

void serialize_output(WINDOW* help, char* help_buffer, int lines, int columns){
	int col_count=0, blen_count=0, y=2;
	int buffer_len = strlen(help_buffer);
	char* hbuf = (char*) malloc(buffer_len+1);
	LOG_CALL(0);
	if(hbuf == NULL){
		LOG_CALL(1);
		return;
	}
	memset(hbuf, '\0', buffer_len+1);
	strncpy(hbuf, help_buffer, buffer_len);
	
	while(blen_count <buffer_len){
		if(col_count == columns){
			wmove(help, y+1, 2);
			(void) wrefresh(help);
			y++;
			col_count=0;	
		}

		(void) waddch(help, *hbuf);
		hbuf++;
		blen_count++;
		col_count++;
	}
	while(blen_count > 0){
		blen_count--;
		hbuf--;
	}
	sfree(hbuf);
	LOG_CALL(1);
}
