#ifndef __LKCP_H__
#define __LKCP_H__

#include <unistd.h>
#include <ncurses.h>
#include <sys/types.h>
#include <dirent.h>
#include <errno.h>

#define LKCP_VERSION "v0.5.4"

#define ESC 27

#define MAX_RECURS_DIR	100

#define sfree(p)        if(p != NULL) free(p);

#define MAIN_DIR	"/proc/sys"
#define PROC_ABI	"/proc/sys/abi"
#define PROC_DEBUG	"/proc/sys/debug"
#define PROC_VM		"/proc/sys/vm"
#define PROC_FS		"/proc/sys/fs"
#define PROC_DEV	"/proc/sys/dev"
#define PROC_KERNEL	"/proc/sys/kernel"
#define PROC_NET	"/proc/sys/net"
#define PROC_SUNRPC	"/proc/sys/sunrpc"
#define PROC_PROC	"/proc/sys/proc"

#define PROC_SYS_ABI	1
#define PROC_SYS_DEBUG	2
#define PROC_SYS_VM	3
#define PROC_SYS_FS	4
#define PROC_SYS_DEV	5
#define PROC_SYS_KERNEL	6
#define PROC_SYS_NET	7
#define PROC_SYS_SUNRPC	8

#define EDIT_MODE       0
#define VIEW_MODE       1


typedef struct {
        int entry;
	char names[100];
	size_t entry_len;
} directentries;


typedef directentries directent;

extern int errno;

directent dent[MAX_RECURS_DIR];

void finish(int sig);

void draw_menuwin(WINDOW* menuwin);

WINDOW **draw_menu(int start_col);

void draw_lkcpwin(WINDOW* lkcpwin);

void draw_dumpwin(WINDOW* dumpwin);

void draw_dumpban(WINDOW* dumpban);

void delete_menu(WINDOW **items,int count);

WINDOW** draw_sys_menuwin(DIR* dir, int start_column);

void set_number_entries(char* dir);

WINDOW *create_configwin(int height, int width, int starty, int startx);
WINDOW *create_exitwin(int height, int width, int starty, int startx);

int scroll_menu(WINDOW **items,int count,int menu_start_col);

void error_screen(void);

void print_menu(char* progname);
#endif
